 contrib/Makefile                                  |   1 +
 contrib/ctidscan/Makefile                         |  19 +
 contrib/ctidscan/ctidscan--1.0.sql                |  12 +
 contrib/ctidscan/ctidscan--unpackaged-1.0.sql     |   0
 contrib/ctidscan/ctidscan.c                       | 952 ++++++++++++++++++++++
 contrib/ctidscan/ctidscan.control                 |   5 +
 contrib/ctidscan/expected/ctidscan.out            | 312 +++++++
 contrib/ctidscan/sql/ctidscan.sql                 |  54 ++
 doc/src/sgml/catalogs.sgml                        |  59 ++
 doc/src/sgml/custom-plan-provider.sgml            | 431 ++++++++++
 doc/src/sgml/filelist.sgml                        |   1 +
 doc/src/sgml/postgres.sgml                        |   1 +
 doc/src/sgml/ref/allfiles.sgml                    |   2 +
 doc/src/sgml/ref/create_custom_plan_provider.sgml | 139 ++++
 doc/src/sgml/ref/drop_custom_plan_provider.sgml   | 108 +++
 doc/src/sgml/reference.sgml                       |   2 +
 src/backend/catalog/Makefile                      |   2 +-
 src/backend/catalog/dependency.c                  |  11 +-
 src/backend/catalog/objectaddress.c               |  63 ++
 src/backend/commands/Makefile                     |   2 +-
 src/backend/commands/custom_plan.c                | 188 +++++
 src/backend/commands/dropcmds.c                   |   5 +
 src/backend/commands/event_trigger.c              |   2 +
 src/backend/commands/explain.c                    |  40 +
 src/backend/executor/Makefile                     |   2 +-
 src/backend/executor/execAmi.c                    |  25 +
 src/backend/executor/execProcnode.c               |  19 +
 src/backend/executor/nodeCustom.c                 | 147 ++++
 src/backend/nodes/copyfuncs.c                     |  35 +
 src/backend/nodes/equalfuncs.c                    |  14 +
 src/backend/nodes/outfuncs.c                      |  33 +
 src/backend/optimizer/path/allpaths.c             |  30 +-
 src/backend/optimizer/plan/createplan.c           |  98 ++-
 src/backend/optimizer/plan/setrefs.c              |  11 +-
 src/backend/optimizer/plan/subselect.c            |  24 +
 src/backend/optimizer/util/pathnode.c             | 110 +++
 src/backend/parser/gram.y                         |  94 ++-
 src/backend/tcop/utility.c                        |  20 +
 src/backend/utils/adt/ruleutils.c                 |  73 ++
 src/backend/utils/cache/syscache.c                |  23 +
 src/include/catalog/dependency.h                  |   1 +
 src/include/catalog/indexing.h                    |   6 +
 src/include/catalog/pg_custom_plan_provider.h     |  50 ++
 src/include/catalog/pg_operator.h                 |   3 +
 src/include/commands/defrem.h                     |   5 +
 src/include/executor/nodeCustom.h                 |  30 +
 src/include/nodes/execnodes.h                     |  42 +
 src/include/nodes/nodes.h                         |   5 +
 src/include/nodes/parsenodes.h                    |  13 +
 src/include/nodes/plannodes.h                     |  37 +
 src/include/nodes/relation.h                      |  26 +
 src/include/optimizer/pathnode.h                  |  14 +
 src/include/optimizer/planmain.h                  |   2 +
 src/include/parser/kwlist.h                       |   4 +
 src/include/utils/syscache.h                      |   2 +
 src/test/regress/expected/sanity_check.out        |   1 +
 56 files changed, 3374 insertions(+), 36 deletions(-)

diff --git a/contrib/Makefile b/contrib/Makefile
index b37d0dd..9b4b6ad 100644
--- a/contrib/Makefile
+++ b/contrib/Makefile
@@ -12,6 +12,7 @@ SUBDIRS = \
 		btree_gist	\
 		chkpass		\
 		citext		\
+		ctidscan	\
 		cube		\
 		dblink		\
 		dict_int	\
diff --git a/contrib/ctidscan/Makefile b/contrib/ctidscan/Makefile
new file mode 100644
index 0000000..1e476a6
--- /dev/null
+++ b/contrib/ctidscan/Makefile
@@ -0,0 +1,19 @@
+# contrib/ctidscan/Makefile
+
+MODULES = ctidscan
+
+EXTENSION = ctidscan
+DATA = ctidscan--1.0.sql
+
+REGRESS = ctidscan
+
+ifdef USE_PGXS
+PG_CONFIG = pg_config
+PGXS := $(shell $(PG_CONFIG) --pgxs)
+include $(PGXS)
+else
+subdir = contrib/ctidscan
+top_builddir = ../..
+include $(top_builddir)/src/Makefile.global
+include $(top_srcdir)/contrib/contrib-global.mk
+endif
diff --git a/contrib/ctidscan/ctidscan--1.0.sql b/contrib/ctidscan/ctidscan--1.0.sql
new file mode 100644
index 0000000..46420a0
--- /dev/null
+++ b/contrib/ctidscan/ctidscan--1.0.sql
@@ -0,0 +1,12 @@
+--
+-- Create ctidscan handler function
+--
+CREATE FUNCTION ctidscanaddpath(internal)
+  RETURNS pg_catalog.void
+  AS 'MODULE_PATHNAME','CtidScanAddPath'
+  LANGUAGE C STRICT;
+
+--
+-- Create a custom-plan provider
+--
+CREATE CUSTOM PLAN PROVIDER ctidscan FOR scan HANDLER ctidscanaddpath;
